
#include "inc.h"

#include "lib.h"
#include "main.h"
#include "div_arm.h"

#include "bullet5way.h"

//---------------------------------------------------------------------------

//main.c
extern ST_MYSHIP     MyShip;
extern ST_BULLET_CTL BulletCtl;
//---------------------------------------------------------------------------
BulletStepFunc Bullet5WayBullet1[] =
{
	NULL,
};

BulletStepFunc Bullet5WayBullet3[] =
{
	Bullet5WayStepWait30,
	Bullet5WayStep301,
	Bullet5WayNULL,
};

BulletStepFunc Bullet5WayBullet5[] =
{
	Bullet5WayStep501,
	Bullet5WayEnd,
};

BulletStepFunc Bullet5WayBullet6[] =
{
	Bullet5WayStepWait30,
	Bullet5WayStep601,
	Bullet5WayStep601,
	Bullet5WayStep601,
	Bullet5WayStep601,
	Bullet5WayStep601,
	Bullet5WayStep601,
	Bullet5WayStep601,
	Bullet5WayStep601,
	Bullet5WayEnd,
};

BulletStepFunc Bullet5WayMain[] =
{
	Bullet5WayStep001,
	Bullet5WayStep002,
	Bullet5WayStep002,
	Bullet5WayStep001,
	Bullet5WayStep002,
	Bullet5WayStep002,
	Bullet5WayStep001,
	Bullet5WayStep002,
	Bullet5WayStep002,
	Bullet5WayStep003,
	Bullet5WayStep004,
	Bullet5WayEnd,
};

BulletStepFunc Bullet5WayNone[] =
{
	Bullet5WayNULL,
};
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WaySet()
{
	ST_BULLET* p = BulletNew(INT2FIX(0), INT2FIX(-40), 0, 0, (void*)Bullet5WayMain);
	p->wait = 20;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayEnd(ST_BULLET* p)
{
	p->y = INT2FIX(160);
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayNULL(ST_BULLET* p)
{
	//
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayStep001(ST_BULLET* p)
{
	BulletNew(p->x, p->y, 64, 1, (void*)Bullet5WayBullet5);
	p->wait = 10;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayStepWait30(ST_BULLET* p)
{
	p->wait = 30;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayStepWait10(ST_BULLET* p)
{
	p->wait = 10;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayStep002(ST_BULLET* p)
{
	BulletNew(p->x, p->y, 150, 1, (void*)Bullet5WayBullet3);
	BulletNew(p->x, p->y, 170, 1, (void*)Bullet5WayBullet3);
	BulletNew(p->x, p->y, 214, 1, (void*)Bullet5WayBullet3);
	BulletNew(p->x, p->y, 234, 1, (void*)Bullet5WayBullet3);

	p->wait = 20;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayStep003(ST_BULLET* p)
{
	p->wait = 100;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayStep004(ST_BULLET* p)
{
	BulletCtl.sw = FALSE;
	p->wait = 1;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayStep501(ST_BULLET* p)
{
	BulletNew(p->x, p->y, 251, 1, (void*)Bullet5WayBullet6);
	BulletNew(p->x, p->y, 133, 1, (void*)Bullet5WayBullet6);

	p->wait = 1;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayStep601(ST_BULLET* p)
{
	u8 angle = CommonGetAngle(MyShip.x, MyShip.y, p->x, p->y);

	BulletNew(p->x, p->y, angle-36, 3, (void*)Bullet5WayNone);
	BulletNew(p->x, p->y, angle-16, 3, (void*)Bullet5WayNone);
	BulletNew(p->x, p->y, angle+16, 3, (void*)Bullet5WayNone);
	BulletNew(p->x, p->y, angle+36, 3, (void*)Bullet5WayNone);

	p->wait = 5;
}
//---------------------------------------------------------------------------
EWRAM_CODE void Bullet5WayStep301(ST_BULLET* p)
{
	ST_BULLET_CTL* c = &BulletCtl;

	u8 angle = CommonGetAngle(MyShip.x, MyShip.y, p->x, p->y);

	c->lastAngle = angle;

	p->angle = c->lastAngle;
	p->speed = c->lastSpeed;
	p->vx    = _Cos(p->angle);
	p->vy    = _Sin(p->angle);

	p->wait = 10;
}

